

// one simulation element, e.g. one job for a machine to process

public class JSElt  

{
   public String JSName;  // name, for debugging purposes
   public float JSEvntTime;  // event occurrence time
   public int JSEltNumber;  // ID number
   public JSElt JSNext;  // pointer to next in event list
   public int JSPartnerEltNumber;  // JSEltNumber for a partner event,
                                   // e.g. a timeout
   public float JSServiceTime;  
  
   // removes head of event list and assigns JSSim.JSCurrEvnt to it
   public static void JSGetNext()
   
   {  JSElt OldEvntListHd;

      OldEvntListHd  = JSSim.JSEvntListHd;
      if (JSSim.JSEvntListHd.JSNext == null)
         JSSim.JSEvntListHd = null;
      else JSSim.JSEvntListHd = JSSim.JSEvntListHd.JSNext;
      JSSim.JSCurrEvnt = OldEvntListHd;
      JSSim.JSCurrEvnt.JSNext = null;
   }
   
   // removes earliest element in event list having JSEltNum value EN
   public static void JSCancel(int EN)

   {  JSElt TmpEltPtr = JSSim.JSEvntListHd;

      if (TmpEltPtr == null) return;

      if (TmpEltPtr.JSEltNumber == EN)  {
         JSSim.JSEvntListHd = TmpEltPtr.JSNext;
         return;
      }

      while (TmpEltPtr.JSNext != null)  {
         if (TmpEltPtr.JSNext.JSEltNumber == EN)  {
            TmpEltPtr.JSNext = TmpEltPtr.JSNext.JSNext;
            return;
         }
         TmpEltPtr = TmpEltPtr.JSNext;   
      }
   
   }
  
   // constructor method
   public JSElt() {  JSEltNumber = JSSim.JSNextNew++; }

   // the following method MUST be overridden by the application
   public void JSEvntHandler() 

   {  System.out.println("JSEvntHandler() not overridden by application");
      System.exit(1);  }

   // inserts this JSElt object into event list
   public void JSInsertInEvntList()  

   {  JSElt Tmp;

      JSNext = null;  // make sure no loose ends

      if (JSSim.JSEvntListHd == null)  {
         JSSim.JSEvntListHd = this;
         return;
      }

      if (JSEvntTime < JSSim.JSEvntListHd.JSEvntTime)  {
         JSNext = JSSim.JSEvntListHd;
         JSSim.JSEvntListHd = this;
         return;
      }

      Tmp = JSSim.JSEvntListHd;
      while (true) {
         if (Tmp.JSNext == null)  {
            Tmp.JSNext = this;
            break;
         }
         else if (JSEvntTime < Tmp.JSNext.JSEvntTime)  {
            JSNext = Tmp.JSNext;
            Tmp.JSNext = this;
            break;
         }
         Tmp = Tmp.JSNext;
      }
   }

   public void JSPrintElt()

   {  System.out.println("JSElt "+this.JSEltNumber+":  "
           +this.JSName+" at "+this.JSEvntTime);
   }

   // used for anti-bugging in application-specific overridden JSEvntHandler()
   public void JSEvntPanic()

   {  System.out.println("event "+JSName+" occurred in inappropriate context");
      System.exit(1);
   }
      
}



